local AddonName, VoiceCoolDown = ...

VoiceCoolDown.SPELL_MONITOR_SCHEMA = {
	["schema"] = "50100",
	["revision"] = 1,
	["spellmetadata"] = {
		-- Death Knight
		[47528] 	= { ["duration"] = "4" },
		[48792] 	= { ["duration"] = "8" },		
		[55233] 	= { ["duration"] = "10" },		
		[51052] 	= { ["duration"] = "3" },
		[48707] 	= { ["duration"] = "5" },
		[20594] 	= { ["2ndcooldown"] = "6" },		
		[47476] 	= { ["duration"] = "5" },
		[49039] 	= { ["duration"] = "10" },

		-- Warrior
		[12975] 	= { ["duration"] = "20" },
		[64382] 	= { ["duration"] = "10" },
		[871] 		= { ["duration"] = "12" },
		[6552] 		= { ["duration"] = "4" },
		[97462] 	= { ["duration"] = "10" },
		[102060] 	= { ["duration"] = "4" },
		[114028] 	= { ["duration"] = "5" },
		
		-- Druid
		[22812] 	= { ["duration"] = "12" },
		[22842] 	= { ["duration"] = "20" },
		[61336] 	= { ["duration"] = "6" },
		[740] 		= { ["duration"] = "6" },
		[33891] 	= { ["duration"] = "30" },
    [102558] 	= { ["duration"] = "30" },
    [102560] 	= { ["duration"] = "30" },
    [102543] 	= { ["duration"] = "30" },
		[5211] 		= { ["duration"] = "5" },
		[102351] 	= { ["duration"] = "30" },
		[102342] 	= { ["duration"] = "12" },
		[124974] 	= { ["duration"] = "30" },
    [102280] 	= { ["duration"] = "4" },
		
		-- Mage
		[45438] 	= { ["duration"] = "10" },
		[80353] 	= { ["duration"] = "40" },
		[2139] 		= { ["duration"] = "6" },
    [159916]	= { ["duration"] = "6" },
    
		
		-- Priest
		[109964] 	= { ["duration"] = "15" },
		[64843] 	= { ["duration"] = "8" },
		[47788] 	= { ["duration"] = "10" },
		[33206] 	= { ["duration"] = "8" },
		[62618] 	= { ["duration"] = "10" },
		[15286] 	= { ["duration"] = "15" },
		[108920] 	= { ["duration"] = "20" },
		
		-- Monk
		[115176] 	= { ["duration"] = "8" },   -- Zen Meditation
		[116849] 	= { ["duration"] = "12" },  -- Life Cocoon
		
		-- Paladin
		[31850] 	= { ["duration"] = "10" },
		[31821] 	= { ["duration"] = "6" },		
		[498] 		= { ["duration"] = "10" },
		[642] 		= { ["duration"] = "8" },
		[1044] 		= { ["duration"] = "6" },
		[1022] 		= { ["duration"] = "10" },
		[6940] 		= { ["duration"] = "12" },
		[1038] 		= { ["duration"] = "10" },
		[114039] 	= { ["duration"] = "6" },
		[96231] 	= { ["duration"] = "4" },
		[853] 		= { ["duration"] = "6" },
		[105593] 	= { ["duration"] = "6" },
		
		-- Rogue
		[2094] 		= { ["duration"] = "60" },
		[31224] 	= { ["duration"] = "5" },
		[1766] 		= { ["duration"] = "5" },
		[114018] 	= { ["duration"] = "15" },
		[76577] 	= { ["duration"] = "5" },
    
    -- Hunter
    [172106] 	= { ["duration"] = "6" }, -- Aspecto del Zorro
    [34477] 	= { ["duration"] = "8" }, -- Redirección
    [19263] 	= { ["duration"] = "5" }, -- Redirección
    

		-- Shaman
		[32182] 	= { ["duration"] = "40" },
    [2825]  	= { ["duration"] = "40" },
		[5394] 		= { ["duration"] = "15" },
		[98008] 	= { ["duration"] = "6" },
		[57994] 	= { ["duration"] = "3" },
		[108280] 	= { ["duration"] = "10" },
		[108281] 	= { ["duration"] = "10" },
		
		-- Warlock
	},
	["requirements"] = {
		[698] 	= { { ["k"] = 10, ["level"] = 42, } },
		[47528] = { { ["k"] = 10, ["level"] = 57, } },
		[48792] = { { ["k"] = 10, ["level"] = 62, } },
		[73325] = { { ["k"] = 10, ["level"] = 85, } },
		[1038] 	= { { ["k"] = 10, ["level"] = 66, } },
		[97462] = { { ["k"] = 10, ["level"] = 83, } },
		[2139] 	= { { ["k"] = 10, ["level"] = 10, } },
		[57994] = { { ["k"] = 10, ["level"] = 16, } },
		[29893] = { { ["k"] = 10, ["level"] = 68, } },
		[6940] 	= { { ["k"] = 10, ["level"] = 80, } },
		[49576] = { { ["k"] = 10, ["level"] = 55, } },
		[42650] = { { ["k"] = 10, ["level"] = 80, } },
		[22842] = { { ["k"] = 10, ["level"] = 68, } },
		[31224] = { { ["k"] = 10, ["level"] = 58, } },
		[34477] = { { ["k"] = 10, ["level"] = 42, } },
		[45438] = { { ["k"] = 10, ["level"] = 30, } },
		[2094] 	= { { ["k"] = 10, ["level"] = 34, } },
		[46584] = { { ["k"] = 10, ["level"] = 56, } },
		[498] 	= { { ["k"] = 10, ["level"] = 30, } },
		[642] 	= { { ["k"] = 10, ["level"] = 48, } },
		[1022] 	= { { ["k"] = 10, ["level"] = 18, } },
		[32182] = { { ["k"] = 10, ["level"] = 70, } },
		[2825]  = { { ["k"] = 10, ["level"] = 70, } },
		[47476] = { { ["k"] = 10, ["level"] = 58, } },
		[6552] 	= { { ["k"] = 10, ["level"] = 38, } },
		[1044] 	= { { ["k"] = 10, ["level"] = 52, } },
		[853] 	= { { ["k"] = 10, ["level"] = 14, } },
		[31687] = { { ["k"] = 10, ["level"] = 10, } },
		[22812] = { { ["k"] = 10, ["level"] = 44, } },
		[80353] = { { ["k"] = 10, ["level"] = 85, } },
		[64382] = { { ["k"] = 10, ["level"] = 74, } },
		[20608] = { { ["k"] = 10, ["level"] = 32, } },
		[48707] = { { ["k"] = 10, ["level"] = 68, } },
		[20484] = { { ["k"] = 10, ["level"] = 56, } },
		[740] 	= { { ["k"] = 10, ["level"] = 74, } },
		[61999] = { { ["k"] = 10, ["level"] = 72, } },
		[64843] = { { ["k"] = 10, ["level"] = 78, } },
		[633] 	= { { ["k"] = 10, ["level"] = 16, } },
		[86150] = { { ["k"] = 10, ["level"] = 85, } },
		
		[109964] = { { ["k"] = 10, ["level"] = 28, } },
		[114018] = { { ["k"] = 10, ["level"] = 76, } },
		[108280] = { { ["k"] = 10, ["level"] = 65, } },
		[114028] = { { ["k"] = 10, ["level"] = 20, } },
    
    -- Shaman
    [2484] = { { ["k"] = 10, ["level"] = 26, } },   -- Tótem de Enlace de Espíritu
    [5394] = { { ["k"] = 10, ["level"] = 30, } },   -- Tótem Corriente de sanación
    
    --Warlock
    [20707] = { { ["k"] = 10, ["level"] = 18, } },
    
    --Mage
    [159916] = { { ["k"] = 10, ["level"] = 87, } },
		
    -- Hunter
		[172106] = { { ["k"] = 10, ["level"] = 84, } }, -- Aspecto de Zorro
		[19263] = { { ["k"] = 10, ["level"] = 78, } },  -- Disuasión
    
		-- Monk
		[115176] = { { ["k"] = 10, ["level"] = 82, } }, -- Zen Meditation
		[116849] = { { ["k"] = 10, ["level"] = 50, } }, -- Life Cocoon
		[115310] = { { ["k"] = 10, ["level"] = 78, } }, -- Revival
		
		-- Priest
		[108920] = { { ["k"] = 10, ["level"] = 15, } }, -- Void Tendrils
    
    -- Druid
    [5215] = { { ["k"] = 10, ["level"] = 6, } }, -- Void Tendrils
		
		-----------------------------------
		-- Talent Requirements
		-----------------------------------
		-- Druid
		[124974] 	= { { ["k"] = 25, ["talentIndex"] = 18 }  },  -- Vigilia de la naturaleza
		[5211] 	  = { { ["k"] = 25, ["talentIndex"] = 15 }  },   -- Azote poderoso
    [102280] 	= { { ["k"] = 25, ["talentIndex"] = 2 } },   -- Bestia trémula
    [102543]  = { { ["k"] = 25, ["talentIndex"] = 11 } },   -- Encarnación...
    [102558]  = { { ["k"] = 25, ["talentIndex"] = 11 } },   -- Encarnación...
    [102560]  = { { ["k"] = 25, ["talentIndex"] = 11 } },   -- Encarnación...
    [33891]   = { { ["k"] = 25, ["talentIndex"] = 11 } },   -- Encarnación: Arbol de vida    
		
		-- Death Knight
		[49039] 	= { { ["k"] = 25, ["talentIndex"] = 4 }	},
		[51052] 	= { { ["k"] = 25, ["talentIndex"] = 5 }	},
		
		[102060] 	= { { ["k"] = 25, ["talentIndex"] = 9 } },
				
		-- Paladin
		[105593] 	= { { ["k"] = 25, ["talentIndex"] = 4 } },
		[20066] 	= { { ["k"] = 25, ["talentIndex"] = 5 } },
		[102351]	= { { ["k"] = 25, ["talentIndex"] = 6 } },
		
		
		-- Priest
		[108920]	= { { ["k"] = 25, ["talentIndex"] = 1 } },
		
		-- Warrior
		[102060]	= { { ["k"] = 25, ["talentIndex"] = 9 } },
		[114028]	= { { ["k"] = 25, ["talentIndex"] = 13 } },
		
		-- Shaman
		[108281]	= { { ["k"] = 25, ["talentIndex"] = 14 } }, -- Ancestral Guidance
		
		-----------------------------------
		-- Specialization Requirements
		-----------------------------------
		
		-- Death Knight (Blood)
		[55233] 	= { { ["k"] = 30, ["specialization"] = 250 } },
		[49222] 	= { { ["k"] = 30, ["specialization"] = 250 } },
		
		-- Druid (Restoration)
		[102342] 	= { { ["k"] = 30, ["specialization"] = 105 } },
		
		-- Mage (Frost)
		[31687] 	= { { ["k"] = 30, ["specialization"] = 64 } },
		
		-- Shaman (Restoration)
		[98008] 	= { { ["k"] = 30, ["specialization"] = 264 } },
		[5394] 		= { { ["k"] = 30, ["specialization"] = 264 } },	-- Healing Stream Totem
		
		-- Priest (Shadow)
		[15286]		= { { ["k"] = 30, ["specialization"] = 258 } }, -- Vampiric Embrace
		
		-- Priest (Holy)
		[64843]		= { { ["k"] = 30, ["specialization"] = 257 } }, -- Divine Hymn
		[47788]		= { { ["k"] = 30, ["specialization"] = 257 } }, -- Guardian Spirit
		
		-- Priest (Discipline)
		[33206]		= { { ["k"] = 30, ["specialization"] = 256 } }, -- Pain Suppression
		[109964]	= { { ["k"] = 30, ["specialization"] = 256 } }, -- Spirit Shell
		[62618]		= { { ["k"] = 30, ["specialization"] = 256 } }, -- Power Word: Barrier
		
		-- Monk (Mistweaver)
		[116849]		= { { ["k"] = 30, ["specialization"] = 270 } }, -- Life Cocoon
		[115310]		= { { ["k"] = 30, ["specialization"] = 270 } }, -- Revival

	},
	
	["cooldowns"] = {
    [172106]  = 180,
    [114030]  = 120,
    [108294]  = 60*6,
    [475]     = 8,
    [81700]   = 30,
    [47585]   = 120,
    [32375]   = 15,
    [10060]   = 120,
    [120517]  = 40,
    [121135]  = 25,
    [110744]  = 15,
    [123904]  = 180,
    [2484]    = 30,
    [5215]    = -10, -- Si el signo es menos -> Que el cooldown comienza cuando termina el fecto del hechizo
    [102280]  = 30,
		[31224] 	= 90,
		[42650] 	= 600,
		[33891] 	= 180,
    [102543] 	= 180,
    [102558] 	= 180,
    [102560] 	= 180,
		[20066] 	= 15,
		[20707] 	= 600,
		[57934] 	= 30,
		[20594] 	= 120,
		[49576] 	= 25,
		[59752] 	= 120,
		[48707] 	= 45,
		[29893] 	= 120,
		[46584] 	= 180,
		[871] 		= 300,
		[80353] 	= 300,
		[633] 		= 600,
		[1022] 		= 300,
		[61336] 	= 180,
		[31687] 	= 180,
		[62618] 	= 180,
		[6940] 		= 120,
		[61999] 	= 600,
		[70940] 	= 180,
		[642] 		= 300,
		[33206] 	= 180,
		[31850] 	= 180,
		[698] 		= 120,
		[2094] 		= 180,
		[45438] 	= 300,
		[498] 		= 60,
		[98008] 	= 180,
		[55233] 	= 60,
		[86150] 	= 300,
		[47788] 	= 180,
		[34477] 	= 30,
		[20484] 	= 600,
		[12975] 	= 180,
		[97462] 	= 180,
		[32182] 	= 300,
    [2825] 	= 300,
		[740] 		= 180,
		[64382] 	= 300,
		[1044] 		= 25,
		[31821] 	= 60 * 3,
		[73325] 	= 90,
		[22812] 	= 60,
		[20608] 	= 1800,
		[22842] 	= 180,
		[51052] 	= 120,
		[48792] 	= 180,
		[49222] 	= 60,
		[1038] 		= 120,
		[64843] 	= 60 * 3,
		[5211] 		= 50, --new
		[47528] 	= 15, --new
		[57994] 	= 12, --new
		[6552] 		= 10, --new
		[96231] 	= 10, --new
		[2139] 		= 24, --new
		[1766] 		= 10, --new
		[853] 		= 60, --new
		[47476] 	= 60, --new
		[102060]	= 40,
		[102351]	= 30,
		[114018]	= 300,
		[108280]	= 180,
		[108281]	= 120,
    [159916]	= 120,
		
		[114028]	= 60,
		
		[109964]	= 60,
		[124974]	= 90,
		
		[115176]	= 180,
		[116849]	= 120,
		[115310]	= 180,
		[5394]		= 30,
		
		[15286]		= 180,
		[108920]	= 30,
		[102342]	= 60,
		[76577]		= 60 * 3,
	},
	["adjustments"] = {
		[740] = { { 	["offset"] = -300, 	["specialization"] = 105, 	["k"] = 30 } },
	},
}